<?php

declare(strict_types=1);

namespace Tests\Feature\API\V1\CatFacts\Rest;

use App\Http\Controllers\API\V1\CatFacts\Rest\UpdateController;
use App\Models\CatFact;
use App\Repositories\BaseFactRepository;
use Tests\TestCase;

class UpdateControllerTest extends TestCase
{
    protected string $updatedFact = 'This is a the updated fact';

    protected ?CatFact $catFact;

    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub

        $this->catFact = new CatFact();
        $this->catFact->fact = 'This is the original fact';

        $this->catFact->save();
    }

    protected function tearDown(): void
    {
        parent::tearDown(); // TODO: Change the autogenerated stub

        if ($this->catFact) {
            $this->cleanUpModels([$this->catFact]);
        }
    }

    public function testSuccess(): void
    {
        $response = $this->putJson("/api/v1/cat-facts/{$this->catFact->id}", [
            'fact' => $this->updatedFact,
        ]);

        $response->assertStatus(200);
        $response->assertJsonFragment([
            'id' => $this->catFact->id,
            'fact' => $this->updatedFact,
        ]);
    }

    public function testNotFound()
    {
        $response = $this->putJson("/api/v1/cat-facts/6942069", [
            'fact' => $this->updatedFact,
        ]);

        $response->assertStatus(404);
    }

    public function testValidationFailure(): void
    {
        $response = $this->putJson("/api/v1/cat-facts/{$this->catFact->id}", []);

        $response->assertStatus(422);

        $response2 = $this->putJson("/api/v1/cat-facts/{$this->catFact->id}", [
            'fact' => null,
        ]);

        $response2->assertStatus(422);

        $response3 = $this->putJson("/api/v1/cat-facts/{$this->catFact->id}", [
            'fact' => 123,
        ]);

        $response3->assertStatus(422);
    }

    public function testHandlesExceptionDuringSave(): void
    {
        $this->app->bind(UpdateController::class, function () {
            $mock = $this->getMockBuilder(BaseFactRepository::class)
                ->onlyMethods(['update'])
                ->getMock();

            $mock->expects($this->once())
                ->method('update')
                ->willThrowException(new \Exception('Some DB error'));

            return new UpdateController($mock);
        });

        $response = $this->putJson("/api/v1/cat-facts/{$this->catFact->id}", [
            'fact' => $this->updatedFact,
        ]);

        $response->assertStatus(500);
    }

    public function testHandlesFailureToSave(): void
    {
        $this->app->bind(UpdateController::class, function () {
            $mock = $this->getMockBuilder(BaseFactRepository::class)
                ->onlyMethods(['update'])
                ->getMock();

            $mock->expects($this->once())
                ->method('update')
                ->willReturn(null);

            return new UpdateController($mock);
        });

        $response = $this->putJson("/api/v1/cat-facts/{$this->catFact->id}", [
            'fact' => $this->updatedFact,
        ]);

        $response->assertStatus(500);
    }
}
